@echo off

:: for jenkins
cd %~dp0

SET PYTHONPATHTOKENS=3
VER | FIND "XP" > nul
IF %ERRORLEVEL% == 0 SET PYTHONPATHTOKENS=4

echo Adding bin folder to Path
set Path=%CD%\bin;%Path%

:: Get protoc.exe for ubuntuone-storage-protocol building
:: This will use the Python on the Path that we got from Buildout
python.exe get_protoc.py


FOR /F "tokens=*" %%A IN ('python -c "import sys;print [dir for dir in sys.path if \"ubuntuone_dev_tools\" in dir][0]"') DO SET DEVTOOLS=%%A
FOR /F "tokens=*" %%A IN ('python -c "import sys;print [dir for dir in sys.path if \"pylint\" in dir][0]"') DO SET PYLINT=%%A
FOR /F "tokens=*" %%A IN ('python -c "import sys;print [dir for dir in sys.path if \"pyflakes\" in dir][0]"') DO SET PYFLAKES=%%A

IF EXIST "%~dp0bin\u1trial" GOTO TRIALALREADY
echo Copying u1trial to bin
copy %DEVTOOLS%\EGG-INFO\scripts\u1trial bin
copy %DEVTOOLS%\EGG-INFO\scripts\u1trial.bat bin
:TRIALALREADY

IF EXIST "%~dp0bin\u1lint" GOTO LINTALREADY
echo Copying u1lint to bin
copy %DEVTOOLS%\EGG-INFO\scripts\u1lint bin
copy %DEVTOOLS%\EGG-INFO\scripts\u1lint.bat bin
:LINTALREADY

IF EXIST "%~dp0bin\pylint" GOTO PYLINTALREADY
echo Copying pylint to bin
copy %PYLINT%\EGG-INFO\scripts\pylint bin
copy %PYLINT%\\EGG-INFO\scripts\pylint.bat bin
:PYLINTALREADY

IF EXIST "%~dp0bin\pyflakes" GOTO PYFLAKESALREADY
echo Copying pyflakes to bin
copy %PYFLAKES%\pyflakes\scripts\pyflakes.py bin\pyflakes
:PYFLAKESALREADY

:: Running ubuntuone-control-panel tests requires -protocol to be built
IF EXIST "%~dp0parts\ubuntuone-storage-protocol\build" GOTO PROTOCOLBUILT
echo Building ubuntuone-storage-protocol
cd parts\ubuntuone-storage-protocol
python.exe setup.py install
cd %~dp0
:PROTOCOLBUILT



:: Run all tests
IF NOT "%1" == "testall" GOTO END

cd parts\ubuntu-sso-client
:: Check for one of the expected reg values and install the value if we don't find it.
FOR /F "tokens=%PYTHONPATHTOKENS%" %%A IN ('REG QUERY "HKEY_LOCAL_MACHINE\SOFTWARE\Ubuntu One" /v path-ubuntuone-syncdaemon') DO SET SYNCDAEMON=%%A
IF NOT %errorlevel% == 0 ubuntu_sso\main\tests\ubuntuone.reg

CALL run-tests.bat
cd "%~dp0"

cd parts\ubuntuone-client
CALL run-tests.bat
cd "%~dp0"

cd parts\ubuntuone-control-panel
CALL run-tests.bat
cd "%~dp0"

cd parts\ubuntuone-windows-installer
CALL run-tests.bat
cd "%~dp0"

:END

